*** WeiDU-185/src/dparser.mly	Mon Jul  4 22:45:15 2005
--- WeiDU/src/dparser.mly	Thu Jan 31 21:48:03 2008
***************
*** 2,7 ****
--- 3,16 ----
  open Util
  open Load
  
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.dparser.mly.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (*** input handle ***)
  
  let current_unit = ref None
***************
*** 32,41 ****
      let buff = Buffer.create (String.length s) in 
      Bcs.print_script_text (the_game()) (Bcs.Save_BCS_Buffer(buff))
          (Bcs.BCS_Print_TriggerList(res)) false None ;
!     Buffer.contents buff 
    with e -> 
!     log_only "WARNING: cannot verify trigger ~%s~: %s\n" s 
        (Printexc.to_string e) ;
      s 
    in 
    pop_context () ; 
--- 41,52 ----
      let buff = Buffer.create (String.length s) in
      Bcs.print_script_text (the_game()) (Bcs.Save_BCS_Buffer(buff))
          (Bcs.BCS_Print_TriggerList(res)) false None ;
!     let result = Buffer.contents buff in
!     result
    with e ->
!     log_and_print "WARNING: cannot verify trigger ~%s~: %s\n" s
        (Printexc.to_string e) ;
+       (try assert false with Assert_failure(file,line,col) -> set_errors file line);
      s
    in 
    pop_context () ;
***************
*** 53,60 ****
          (Bcs.BCS_Print_ActionList(res)) false None ;
      Buffer.contents buff 
    with e -> 
!     log_only "WARNING: cannot verify action ~%s~: %s\n" s 
        (Printexc.to_string e) ;
      s 
    in
    pop_context () ; 
--- 64,72 ----
          (Bcs.BCS_Print_ActionList(res)) false None ;
      Buffer.contents buff
    with e ->
!     log_and_print "WARNING: cannot verify action ~%s~: %s\n" s
        (Printexc.to_string e) ;
+       (try assert false with Assert_failure(file,line,col) -> set_errors file line);
      s
    in
    pop_context () ;
***************
*** 71,239 ****
  
  %}
  
- %token QUESTION COLON SEMICOLON
- %token ACTION_IF
- %token PATCH_IF
- %token ADD_CRE_ITEM
- %token DESCRIBE_ITEM
- %token ADD_KIT
- %token ADD_KNOWN_SPELL
- %token ADD_MAP_NOTE
- %token ADD_MUSIC
- %token ADD_PROJECTILE
  %token ADD_STATE_TRIGGER
  %token ADD_TRANS_TRIGGER
  %token ADD_TRANS_ACTION
! %token ADD_STORE_ITEM
! %token ALLOW_MISSING
! %token ALWAYS
! %token AND OR NOT ELSE LPAREN RPAREN
  %token APPEND
  %token APPEND_EARLY
- %token APPEND_FILE
  %token APPENDI
- %token APPEND_COL
- %token ASK_EVERY_COMPONENT
- %token AT_EXIT
- %token AT_INTERACTIVE_EXIT
- %token AT_INTERACTIVE_UNINSTALL
- %token SET_2DA_ENTRY
- %token COUNT_2DA_ROWS
- %token SET_2DA_ENTRY_LATER
- %token SET_2DA_ENTRIES_NOW
- %token READ_2DA_ENTRY
- %token AT_UNINSTALL
- %token AUTHOR
- %token AUTO_TRA
- %token BACKUP
  %token BEGIN
! %token BUT_ONLY_IF_IT_CHANGES
  %token CHAIN2
  %token CHAIN3
- %token COMPILE
- %token COMPILE_BAF_TO_BCS
- %token COMPILE_D_TO_DLG
- %token DECOMPILE_BCS_TO_BAF
- %token DECOMPILE_DLG_TO_D
- %token COPY
- %token GLOB
- %token EQUIP
- %token TWOHANDED
- %token COPY_EXISTING
- %token COPY_EXISTING_REGEXP
- %token COPY_RANDOM
  %token COPY_TRANS
! %token DELETE_BYTES
! %token DEPRECATED
! %token DESIGNATED
  %token DO
  %token END
  %token EQUALS
  %token EQUALSEQUALS
- %token NOTEQUALS
  %token EXIT
  %token EXTEND_BOTTOM
  %token EXTEND_BOTTOM_REGEXP
  %token EXTEND_TOP
  %token EXTEND_TOP_REGEXP
  %token EXTERN
- %token EVALUATE_BUFFER
- %token FAIL 
- %token FILE_CONTAINS
- %token FILE_CONTAINS_EVALUATED
- %token FILE_MD5
- %token FILE_EXISTS
- %token FILE_EXISTS_IN_GAME
- %token FILE_SIZE
  %token FLAGS
- %token FORBID_FILE
- %token FOR 
  %token GOTO
- %token GT GTE LT LTE
- %token BAND BOR BXOR
- %token BLSL BASR BLSR BNOT
- %token SET_IDS_SYMBOL_OF_INT
  %token IF
! %token SET
! %token IF_EVAL
! %token IF_SIZE_IS
! %token INSERT_BYTES
! %token INSERT_FILE
  %token INTERJECT
  %token INTERJECT_COPY_TRANS
  %token INTERJECT_COPY_TRANS2
  %token JOURNAL SOLVED_JOURNAL UNSOLVED_JOURNAL
! %token LANGUAGE
! %token MENU_STYLE
! %token MKDIR
! %token NO_LOG_RECORD
! %token PATCH_GAM
! %token TIMESTIMES
! %token PLUS MINUS TIMES DIVIDE
! %token PLUS_EQUALS MINUS_EQUALS TIMES_EQUALS DIVIDE_EQUALS OR_EQUALS AND_EQUALS BLSL_EQUALS BLSR_EQUALS
! %token PRINT 
! %token SPRINT 
! %token SNPRINT 
! %token PATCH_PRINT 
! %token RANDOM_SEED PATCH_RANDOM_SEED
! %token RANDOM
! %token READ_ASCII
! %token READ_STRREF
! %token READ_BYTE
! %token READ_SBYTE
! %token READ_SSHORT
! %token READ_LONG
! %token READ_SHORT
! %token REMOVE_KNOWN_SPELL
  %token REPLACE
  %token REPLACE_ACTION_TEXT
  %token REPLACE_ACTION_TEXT_PROCESS
  %token REPLACE_ACTION_TEXT_REGEXP
  %token REPLACE_ACTION_TEXT_PROCESS_REGEXP
- %token REPLACE_BCS_BLOCK
- %token REPLACE_BCS_BLOCK_REGEXP
- %token APPLY_BCS_PATCH
- %token APPLY_BCS_PATCH_OR_COPY
  %token REPLACE_SAY
  %token REPLACE_STATE_TRIGGER
! %token REPLACE_TEXTUALLY
! %token REPLACE_EVALUATE
  %token REPLACE_TRIGGER_TEXT
  %token REPLACE_TRIGGER_TEXT_REGEXP
  %token REPLY
- %token REQUIRE_FILE
- %token REQUIRE_PREDICATE
- %token REQUIRE_COMPONENT
- %token INSTALL_BY_DEFAULT
- %token FORBID_COMPONENT
  %token SAY
- %token SAY_EVALUATED
- %token SUBCOMPONENT
- %token SCRIPT_STYLE
  %token SET_WEIGHT
- %token STRING
  %token STRING_CONCAT
- %token STRING_SET
- %token STRING_SET_RANGE
- %token STRING_EQUAL
- %token STRING_EQUAL_CASE
- %token STRING_MATCHES_REGEXP
- %token STRING_CONTAINS_REGEXP
  %token THEN
- %token UNINSTALL
- %token UNLESS
- %token USING
  %token WEIGHT
- %token WRITE_ASCII
- %token WRITE_EVALUATED_ASCII
- %token WRITE_BYTE
- %token WRITE_FILE
- %token WRITE_LONG
- %token WRITE_SHORT
- %token WHILE
- %token INNER_ACTION
- %token INNER_PATCH
- %token INNER_PATCH_FILE
  
  %token EOF
  
--- 83,138 ----
  
  %}
  
  %token ADD_STATE_TRIGGER
  %token ADD_TRANS_TRIGGER
  %token ADD_TRANS_ACTION
! %token ALTER_TRANS
  %token APPEND
  %token APPEND_EARLY
  %token APPENDI
  %token BEGIN
! %token BRANCH
  %token CHAIN2
  %token CHAIN3
  %token COPY_TRANS
! %token COPY_TRANS_LATE
  %token DO
  %token END
  %token EQUALS
  %token EQUALSEQUALS
  %token EXIT
  %token EXTEND_BOTTOM
  %token EXTEND_BOTTOM_REGEXP
  %token EXTEND_TOP
  %token EXTEND_TOP_REGEXP
  %token EXTERN
  %token FLAGS
  %token GOTO
  %token IF
! %token IF_FILE_EXISTS
  %token INTERJECT
  %token INTERJECT_COPY_TRANS
  %token INTERJECT_COPY_TRANS2
+ %token INTERJECT_COPY_TRANS3
+ %token INTERJECT_COPY_TRANS4
  %token JOURNAL SOLVED_JOURNAL UNSOLVED_JOURNAL
! %token PLUS
  %token REPLACE
  %token REPLACE_ACTION_TEXT
  %token REPLACE_ACTION_TEXT_PROCESS
  %token REPLACE_ACTION_TEXT_REGEXP
  %token REPLACE_ACTION_TEXT_PROCESS_REGEXP
  %token REPLACE_SAY
  %token REPLACE_STATE_TRIGGER
! %token REPLACE_TRANS_ACTION
  %token REPLACE_TRIGGER_TEXT
  %token REPLACE_TRIGGER_TEXT_REGEXP
  %token REPLY
  %token SAY
  %token SET_WEIGHT
  %token STRING_CONCAT
  %token THEN
  %token WEIGHT
  
  %token EOF
  
***************
*** 241,268 ****
  %token <string * string> INLINED_FILE
  %token <int> STRING_REF TRANS_REF FORCED_STRING_REF
  
! %right QUESTION COLON
! %left OR
! %left AND
! %left BOR
! %left BXOR
! %left BAND
! %left EQUALS EQUALSEQUALS NOTEQUALS STRING_EQUAL STRING_EQUAL_CASE STRING_MATCHES_REGEXP STRING_CONTAINS_REGEXP 
! %left GT GTE LT LTE 
! %left BLSL BLSR BASR 
! %left PLUS MINUS
! %left TIMES DIVIDE
! %left TIMESTIMES
! %right NOT BNOT
  
  /* Non-terminals informations */
! %start d_file tra_file tp_file log_file
  
- %type <(string * int * int * (string option)) list> log_file installed_mod_list
  %type <(string * int)> begin_prologue
! %type <(string)> append_prologue replace_prologue
  %type <(bool * string * (string list) * int)> extend_prologue
! %type <(string * string * string * bool)> interject_prologue interject_copy_trans_prologue
  %type <Dc.action list> d_file action_list
  %type <Dc.action> action
  %type <Dlg.state list> state_list state
--- 140,156 ----
  %token <string * string> INLINED_FILE
  %token <int> STRING_REF TRANS_REF FORCED_STRING_REF
  
! %left EQUALS EQUALSEQUALS
! %left PLUS 
  
  /* Non-terminals informations */
! %start d_file tra_file log_file
  
  %type <(string * int)> begin_prologue
! %type <(string * bool)> append_prologue
! %type <(string)> replace_prologue
  %type <(bool * string * (string list) * int)> extend_prologue
! %type <(string * string * string * bool * bool)> interject_prologue interject_copy_trans_prologue
  %type <Dc.action list> d_file action_list
  %type <Dc.action> action
  %type <Dlg.state list> state_list state
***************
*** 286,307 ****
  
  %type <(int * Dlg.tlk_string) list> tra_file
  
- %type <Tp.tp_file> tp_file
- %type <Tp.tp_lang list> tp_lang_list
- %type <Tp.tp_flag list> tp_flag_list
- %type <Tp.tp_mod list> tp_mod_list
- %type <Tp.tp_action list> tp_action_list
- %type <Tp.tp_action> tp_action
- %type <Tp.tp_constraint list> tp_when_list
- %type <(string * string) list> str_str_list
- %type <Tp.tp_patch list> tp_patch_list
  %type <string list> string_list
  %type <int list> int_list
  %type <string list> upper_string_list
  %type <int> hash_int_option
  
! %type <string option * string> appendi_prologue
  
  %%
  
  d_file : action_list   { let answer = $1 @ !extra_actions in 
--- 174,188 ----
  
  %type <(int * Dlg.tlk_string) list> tra_file
  
  %type <string list> string_list
+ %type <(string * string) list> alter_trans_list
  %type <int list> int_list
  %type <string list> upper_string_list
  %type <int> hash_int_option
  
! %type <(string * int * int * (string option)) list> log_file installed_mod_list
  
+ %type <string option * string> appendi_prologue
  %%
  
  d_file : action_list   { let answer = $1 @ !extra_actions in
***************
*** 320,330 ****
  
  append_prologue : APPEND STRING       
        { current_unit := Some(String.uppercase $2) ; 
!         (String.uppercase $2) } ; 
  
  append_safe_prologue : APPEND_EARLY STRING       
        { current_unit := Some(String.uppercase $2) ; 
!         (String.uppercase $2) } ; 
  
  extend_prologue : 
    EXTEND_TOP STRING string_list hash_int_option 
--- 201,272 ----
  
  append_prologue : APPEND STRING       
        { current_unit := Some(String.uppercase $2) ;
!         (String.uppercase $2,false) } ;
! | APPEND IF_FILE_EXISTS STRING
!       { current_unit := Some(String.uppercase $3) ;
!         (String.uppercase $3,true) } ;
  
  append_safe_prologue : APPEND_EARLY STRING
        { current_unit := Some(String.uppercase $2) ;
!         (String.uppercase $2,false) } ;
! | APPEND_EARLY IF_FILE_EXISTS STRING
!       { current_unit := Some(String.uppercase $3) ;
!         (String.uppercase $3,true) } ;
! 
! 
! string_list :            { [] }
! | STRING string_list  { $1 :: $2 } 
! ;
! 
! alter_trans_list :            { [] }
! | STRING STRING alter_trans_list  {
! 	let handle f =
! 		let con = the_context () in
! 		let filename = (Printf.sprintf "ALTER_TRANS stuff list near line %d, column %d of %s"
! 			con.line con.col con.filename) in
! 		let result = begin try
! 				($1, f $2) :: $3
! 			with e ->
! 				log_and_print "WARNING: can not verify %s parameter for %s" $1 filename;
! 				(try assert false with Assert_failure(file,line,col) -> set_errors file line);
! 				($1, $2) :: $3
! 			end
! 		in
! 		result
! 	in
! 	match String.uppercase $1 with
! 	| "TRIGGER" -> handle verify_trigger_list
! 	| "ACTION" -> handle verify_action_list
! 	| "REPLY" | "JOURNAL" | "SOLVED_JOURNAL" | "UNSOLVED_JOURNAL" ->
! 		handle (fun s -> 
! 			try begin
! 				match s.[0] with
! 				| '@' -> "@" ^ string_of_int(int_of_string(Str.string_after s 1))
! 				| '#' -> "#" ^ string_of_int(int_of_string(Str.string_after s 1))
! 				| _ -> s
! 			end with _ -> s
! 		)
! 	| "EPILOGUE" -> handle (fun s ->
! 			let parts = Str.split (Str.regexp " ") s in
! 			if (match parts with
! 			| [a;b;c] -> a <> "EXTERN"
! 			| [a;b] -> a <> "GOTO" && a <> "+"
! 			| [a] -> a <> "EXIT"
! 			| _ -> true) then failwith "Wrong EPILOGUE for ALTER_TRANS";
! 			s
! 		)
! 	| "FLAGS" -> handle (fun s -> string_of_int (int_of_string s))
! 	| _ -> failwith(Printf.sprintf "DPUnknown ALTER_TRANS command: %s" $1)
! }
! ;
! 
! int_list:   { [] }
! | STRING int_list  { (my_int_of_string $1) :: $2 }
! ;
! 
! upper_string_list :            { [] }
! | STRING upper_string_list  { (String.uppercase $1) :: $2 }
! ;
  
  extend_prologue :
    EXTEND_TOP STRING string_list hash_int_option 
***************
*** 364,381 ****
  ; 
  
  chain3_prologue : CHAIN3 optional_weighted_condition STRING STRING 
!   { current_unit := Some(String.uppercase $3); ($2,String.uppercase $3,$4) } 
  ;
  
  interject_prologue : INTERJECT STRING STRING STRING
!   { current_unit := Some(String.uppercase $2); (String.uppercase $2,$3,$4,false) } 
  ;
  
  interject_copy_trans_prologue : INTERJECT_COPY_TRANS STRING STRING STRING
!   { current_unit := Some(String.uppercase $2); (String.uppercase $2,$3,$4,false) } 
  | INTERJECT_COPY_TRANS2 STRING STRING STRING 
!   { current_unit := Some(String.uppercase $2); (String.uppercase $2,$3,$4,true) } 
! 
  ;
  
  action : 
--- 306,330 ----
  ;
  
  chain3_prologue : CHAIN3 optional_weighted_condition STRING STRING
!   { current_unit := Some(String.uppercase $3); ($2,String.uppercase $3,$4,false) }
! | CHAIN3 optional_weighted_condition IF_FILE_EXISTS STRING STRING
!   { current_unit := Some(String.uppercase $4); ($2,String.uppercase $4,$5,true) }
  ;
  
  interject_prologue : INTERJECT STRING STRING STRING
!   { current_unit := Some(String.uppercase $2); (String.uppercase $2,$3,$4,false,false) }
  ;
  
  interject_copy_trans_prologue : INTERJECT_COPY_TRANS STRING STRING STRING
!   { current_unit := Some(String.uppercase $2); (String.uppercase $2,$3,$4,false,false) }
!   /* first boolean = enable don't copy actions a la ICT2; second boolean: add all transitions a la
!      ICT3 */
  | INTERJECT_COPY_TRANS2 STRING STRING STRING
!   { current_unit := Some(String.uppercase $2); (String.uppercase $2,$3,$4,true,false) }
! | INTERJECT_COPY_TRANS3 STRING STRING STRING
!   { current_unit := Some(String.uppercase $2); (String.uppercase $2,$3,$4,false,true) }
! | INTERJECT_COPY_TRANS4 STRING STRING STRING
!   { current_unit := Some(String.uppercase $2); (String.uppercase $2,$3,$4,true,true) }
  ;
  
  action : 
***************
*** 384,392 ****
      Dlg.state = Array.of_list $2 ;
      Dlg.dlg_flags = flags ; })}
  | append_prologue state_list END 
!   { current_unit := None ; Dc.Append( $1 , $2 ) } 
  | append_safe_prologue state_list END 
!   { current_unit := None ; Dc.Append_Early( $1 , $2 ) } 
  | extend_prologue transition_list END 
    { let top,ext_unit,ext_label,number = $1 in
      current_unit := None ; 
--- 333,341 ----
      Dlg.state = Array.of_list $2 ;
      Dlg.dlg_flags = flags ; })}
  | append_prologue state_list END 
!   {let a,b=$1 in current_unit := None ; Dc.Append( a,b , $2 ) }
  | append_safe_prologue state_list END
!   { let a,b=$1 in current_unit := None ; Dc.Append_Early( a,b , $2 ) }
  | extend_prologue transition_list END 
    { let top,ext_unit,ext_label,number = $1 in
      current_unit := None ; 
***************
*** 419,429 ****
    { current_unit := Some(String.uppercase $2);
      let verified_a = verify_action_list $9 in 
      current_unit := None ; 
!     Dc.Add_Trans_Action($2,$4,$7,verified_a) }
  | SET_WEIGHT STRING STRING STRING_REF
    { Dc.Set_Weight($2,$3,$4) }
  | chain3_prologue chain3_list compound_chain3_list chain3_epilogue
!   { let (entry_weight,entry_cond),file,state = $1 in 
      let first_part = List.map (fun (cond,says,action) -> 
        {
          Dc.c3du_speaker = file ;
--- 368,384 ----
    { current_unit := Some(String.uppercase $2);
      let verified_a = verify_action_list $9 in
      current_unit := None ; 
!     Dc.Add_Trans_Action(String.uppercase $2,$4,$7,verified_a) }
! | ALTER_TRANS STRING BEGIN string_list END BEGIN int_list END BEGIN alter_trans_list END
! { Dc.Alter_Trans(String.uppercase $2,$4,$7,$10) }
! | REPLACE_TRANS_ACTION STRING BEGIN string_list END BEGIN int_list END STRING STRING
! { current_unit := Some(String.uppercase $2);
!     current_unit := None ; 
!     Dc.Replace_Trans_Action(String.uppercase $2,$4,$7,$9,$10) }
  | SET_WEIGHT STRING STRING STRING_REF
    { Dc.Set_Weight($2,$3,$4) }
  | chain3_prologue chain3_list compound_chain3_list chain3_epilogue
!   { let (entry_weight,entry_cond),file,state,ifexist = $1 in
      let first_part = List.map (fun (cond,says,action) ->
        {
          Dc.c3du_speaker = file ;
***************
*** 431,475 ****
          Dc.c3du_action = action ;
          Dc.c3du_say = says ;
          Dc.c3du_id = Dc.get_c3du_counter () ; 
        } ) $2 in 
      Dc.Chain3
      {
        Dc.c3_entry_condition = entry_cond;
        Dc.c3_entry_weight = entry_weight;
        Dc.c3_entry_file = file ;
        Dc.c3_entry_label = state ;
        Dc.c3_dialogue = first_part @ $3 ;
        Dc.c3_variable = None ; 
        Dc.c3_exit_trans = $4 ; 
        Dc.c3_keep_first_do_with_first_speaker = false; 
      } 
    } 
  | interject_prologue compound_chain3_list chain3_epilogue
!   { let file,label,var,keep_do = $1 in 
      Dc.Chain3
      {
        Dc.c3_entry_condition = None;
        Dc.c3_entry_weight = Dlg.Not_Specified;
        Dc.c3_entry_file = file ;
        Dc.c3_entry_label = label ;
        Dc.c3_dialogue = $2 ;
        Dc.c3_variable = Some(var) ; 
        Dc.c3_exit_trans = $3 ;
        Dc.c3_keep_first_do_with_first_speaker = keep_do; 
      } 
    } 
  | interject_copy_trans_prologue compound_chain3_list END
!   { let file,label,var,keep_do = $1 in 
      Dc.Chain3
      {
        Dc.c3_entry_condition = None;
        Dc.c3_entry_weight = Dlg.Not_Specified;
        Dc.c3_entry_file = file ;
        Dc.c3_entry_label = label ;
        Dc.c3_dialogue = $2 ;
        Dc.c3_variable = Some(var) ; 
        Dc.c3_exit_trans = [| Dlg.make_trans_of_next (Dlg.Copy(file,label)) |] ;
        Dc.c3_keep_first_do_with_first_speaker = keep_do; 
      } 
    } 
  | REPLACE_TRIGGER_TEXT STRING STRING STRING 
--- 386,437 ----
          Dc.c3du_action = action ;
          Dc.c3du_say = says ;
          Dc.c3du_id = Dc.get_c3du_counter () ;
+         Dc.c3du_ifexists = false ;
        } ) $2 in
      Dc.Chain3
      {
        Dc.c3_entry_condition = entry_cond;
        Dc.c3_entry_weight = entry_weight;
+       Dc.c3_iffileexists = ifexist;
        Dc.c3_entry_file = file ;
        Dc.c3_entry_label = state ;
        Dc.c3_dialogue = first_part @ $3 ;
        Dc.c3_variable = None ;
        Dc.c3_exit_trans = $4 ;
        Dc.c3_keep_first_do_with_first_speaker = false;
+       Dc.c3_append_all = false ;
      }
    }
  | interject_prologue compound_chain3_list chain3_epilogue
!   { let file,label,var,keep_do,append_all = $1 in
      Dc.Chain3
      {
        Dc.c3_entry_condition = None;
        Dc.c3_entry_weight = Dlg.Not_Specified;
        Dc.c3_entry_file = file ;
+       Dc.c3_iffileexists = false;
        Dc.c3_entry_label = label ;
        Dc.c3_dialogue = $2 ;
        Dc.c3_variable = Some(var) ;
        Dc.c3_exit_trans = $3 ;
        Dc.c3_keep_first_do_with_first_speaker = keep_do;
+       Dc.c3_append_all = append_all ;
      }
    }
  | interject_copy_trans_prologue compound_chain3_list END
!   { let file,label,var,keep_do,append_all = $1 in
      Dc.Chain3
      {
        Dc.c3_entry_condition = None;
        Dc.c3_entry_weight = Dlg.Not_Specified;
        Dc.c3_entry_file = file ;
+       Dc.c3_iffileexists = false;
        Dc.c3_entry_label = label ;
        Dc.c3_dialogue = $2 ;
        Dc.c3_variable = Some(var) ;
        Dc.c3_exit_trans = [| Dlg.make_trans_of_next (Dlg.Copy(file,label)) |] ;
        Dc.c3_keep_first_do_with_first_speaker = keep_do;
+       Dc.c3_append_all = append_all ;
      }
    }
  | REPLACE_TRIGGER_TEXT STRING STRING STRING
***************
*** 501,515 ****
                            Some(verified_action) } 
  ; 
  
! chain3_epilogue: END STRING STRING   
!     { let next = Dlg.Symbolic(String.uppercase $2,$3) in
        [| Dlg.make_trans_of_next next |] }
  | EXTERN STRING STRING               
!     { let next = Dlg.Symbolic(String.uppercase $2,$3) in
        [| Dlg.make_trans_of_next next |] }
  | COPY_TRANS STRING STRING           
      { let next = Dlg.Copy(String.uppercase $2,$3) in 
        [| Dlg.make_trans_of_next next |] }
  | EXIT                               
      { let next = Dlg.Exit in 
        [| Dlg.make_trans_of_next next |] }
--- 463,481 ----
                            Some(verified_action) } 
  ; 
  
! chain3_epilogue: 
! | END STRING STRING
!     { let next = Dlg.Symbolic(String.uppercase $2,$3,false) in
        [| Dlg.make_trans_of_next next |] }
  | EXTERN STRING STRING
!     { let next = Dlg.Symbolic(String.uppercase $2,$3,false) in
        [| Dlg.make_trans_of_next next |] }
  | COPY_TRANS STRING STRING
      { let next = Dlg.Copy(String.uppercase $2,$3) in
        [| Dlg.make_trans_of_next next |] }
+ | COPY_TRANS_LATE STRING STRING
+     { let next = Dlg.Copy_Late(String.uppercase $2,$3) in
+       [| Dlg.make_trans_of_next next |] }
  | EXIT
      { let next = Dlg.Exit in
        [| Dlg.make_trans_of_next next |] }
***************
*** 520,530 ****
  | IF weight STRING THEN { ($2,(Some(verify_trigger_list $3))) } 
  ; 
  
- optional_evaluate :
- | { false }
- | EVALUATE_BUFFER { true }
- ; 
- 
  optional_condition :    
  | IF STRING optional_then  { Some(verify_trigger_list $2) } 
  | { None }
--- 486,491 ----
***************
*** 539,547 ****
--- 500,532 ----
          Dc.c3du_action = action ;
          Dc.c3du_say = says ;
          Dc.c3du_id = Dc.get_c3du_counter () ;
+         Dc.c3du_ifexists = false ;
          }) $3 in
      first_part @ $4
    }
+ | EQUALSEQUALS IF_FILE_EXISTS STRING chain3_list compound_chain3_list
+   { let this_speaker = String.uppercase $3 in
+     let first_part = List.map (fun (cond,says,action) ->
+       { Dc.c3du_speaker = this_speaker ;
+         Dc.c3du_condition = cond ;
+         Dc.c3du_action = action ;
+         Dc.c3du_say = says ;
+         Dc.c3du_id = Dc.get_c3du_counter () ;
+         Dc.c3du_ifexists = true ;
+         }) $4 in
+     first_part @ $5
+   }
+ | BRANCH STRING BEGIN compound_chain3_list END compound_chain3_list
+   {
+     List.map (fun x ->
+       {
+         x with
+           Dc.c3du_condition = match x.Dc.c3du_condition with
+             | None -> Some ($2)
+             | Some(y) -> Some($2 ^ " " ^ y)
+       }
+     ) $4 @ $6
+   }
  ;
  
  
***************
*** 599,605 ****
  | appendi_prologue state_list END
    {
      let old_unit, append_name = $1 in 
!     extra_actions := (Dc.Append( append_name, $2 )) :: !extra_actions ;
      current_unit := old_unit ;
      [] 
    }
--- 584,590 ----
  | appendi_prologue state_list END
    {
      let old_unit, append_name = $1 in
!     extra_actions := (Dc.Append( append_name,false, $2 )) :: !extra_actions ;
      current_unit := old_unit ;
      [] 
    }
***************
*** 674,683 ****
        Dlg.next = $5 ; 
      } in
      List.iter (fun elt -> match elt with
!     | Trans_Reply(r) -> result.Dlg.trans_str <- r ;
!     | Trans_Do(r) -> result.Dlg.action <- r ;
      | Trans_Journal(r) -> 
!         (if (result.Dlg.journal_str <> None) then 
           try parse_error "You may only have one JOURNAL per transition.  Recovering." with _ -> ()) ;
          result.Dlg.journal_str <- r;
      | Trans_Flags(r) -> result.Dlg.unknown_flags <- r;
--- 659,677 ----
        Dlg.next = $5 ;
      } in
      List.iter (fun elt -> match elt with
!     | Trans_Reply(r) -> (if (result.Dlg.trans_str <> None) && !debug_modder then
!          try parse_error "You may only have one REPLY per transition.  Recovering."
!          with _ -> ()) ; result.Dlg.trans_str <- r ;
!     | Trans_Do(r) ->(if (result.Dlg.action <> None) && !debug_modder then
!          try
!            parse_error "You may only have one DO per transition.  Recovering."
!          with _ -> ()) ;
!          let r = try Some(
!            value_of_option r ^ value_of_option result.Dlg.action
!          ) with _ -> r in
!          result.Dlg.action <- r ;
      | Trans_Journal(r) ->
!         (if (result.Dlg.journal_str <> None) && !debug_modder then
           try parse_error "You may only have one JOURNAL per transition.  Recovering." with _ -> ()) ;
          result.Dlg.journal_str <- r;
      | Trans_Flags(r) -> result.Dlg.unknown_flags <- r;
***************
*** 696,704 ****
        Dlg.next = $6 ; 
      } in
      List.iter (fun elt -> match elt with
!     | Trans_Reply(r) -> result.Dlg.trans_str <- r ;
!     | Trans_Do(r) -> result.Dlg.action <- r ;
!     | Trans_Journal(r) -> result.Dlg.journal_str <- r;
      | Trans_Flags(r) -> result.Dlg.unknown_flags <- r;
      ) $5 ;
      result 
--- 690,710 ----
        Dlg.next = $6 ;
      } in
      List.iter (fun elt -> match elt with
!     | Trans_Reply(r) -> (if (result.Dlg.trans_str <> None) && !debug_modder then
!          try parse_error "You may only have one REPLY per transition.  Recovering."
!          with _ -> ()) ; result.Dlg.trans_str <- r ;
!     | Trans_Do(r) ->(if (result.Dlg.action <> None) && !debug_modder then
!          try
!            parse_error "You may only have one DO per transition.  Recovering."
!          with _ -> ()) ;
!          let r = try Some(
!            value_of_option r ^ value_of_option result.Dlg.action
!          ) with _ -> r in
!          result.Dlg.action <- r ;
!     | Trans_Journal(r) ->
!         (if (result.Dlg.journal_str <> None) && !debug_modder then
!          try parse_error "You may only have one JOURNAL per transition.  Recovering." with _ -> ()) ;
!         result.Dlg.journal_str <- r;
      | Trans_Flags(r) -> result.Dlg.unknown_flags <- r;
      ) $5 ;
      result
***************
*** 710,723 ****
        Dlg.action = None ;
        Dlg.journal_str = None;
        Dlg.unknown_flags = 0 ;
!       Dlg.next = Dlg.Copy($2,$3) ;
      } 
    } 
  ;
  
! next : GOTO STRING     { Dlg.Symbolic(get_current_unit () ,$2) }
! | PLUS STRING     { Dlg.Symbolic(get_current_unit () ,$2) }
! | EXTERN STRING STRING { Dlg.Symbolic(String.uppercase $2,$3) } 
  | EXIT                 { Dlg.Exit } 
  ; 
  
--- 716,740 ----
        Dlg.action = None ;
        Dlg.journal_str = None;
        Dlg.unknown_flags = 0 ;
!       Dlg.next = Dlg.Copy(String.uppercase $2,$3) ;
!     }
!   }
! | COPY_TRANS_LATE STRING STRING
!   { {
!       Dlg.trans_trigger = None ;
!       Dlg.trans_str = None ;
!       Dlg.action = None ;
!       Dlg.journal_str = None;
!       Dlg.unknown_flags = 0 ;
!       Dlg.next = Dlg.Copy_Late(String.uppercase $2,$3) ;
      }
    }
  ;
  
! next : GOTO STRING     { Dlg.Symbolic(get_current_unit () ,$2,false) }
! | PLUS STRING     { Dlg.Symbolic(get_current_unit () ,$2,false) }
! | EXTERN STRING STRING { Dlg.Symbolic(String.uppercase $2,$3,false) }
! | EXTERN IF_FILE_EXISTS STRING STRING { Dlg.Symbolic(String.uppercase $3,$4,true) }
  | EXIT                 { Dlg.Exit }
  ;
  
***************
*** 758,1205 ****
  | TRANS_REF EQUALS lse tra_file { ($1,$3) :: $4 } 
  ;
  
- tp_file : 
- BACKUP STRING AUTHOR STRING tp_flag_list tp_lang_list tp_mod_list 
-   { { Tp.tp_filename = $2 ; 
-       Tp.backup = $2;
-       Tp.author = $4; 
-       Tp.flags = $5 ;
-       Tp.languages = $6 ;
-       Tp.module_list = $7 ;
-   } }
- ; 
- 
- tp_flag_list :                  { [] } 
- | AUTO_TRA STRING tp_flag_list         { (Tp.Auto_Tra($2)) :: $3 } 
- | MENU_STYLE STRING tp_flag_list       { (Tp.Menu_Style($2)) :: $3 } 
- | ASK_EVERY_COMPONENT tp_flag_list     { (Tp.Ask_Every_Component) :: $2 } 
- | ALWAYS tp_action_list END tp_flag_list   { (Tp.Always($2)) :: $4 } 
- | ALLOW_MISSING upper_string_list tp_flag_list
-     { Tp.Allow_Missing($2) :: $3 }
- | SCRIPT_STYLE STRING tp_flag_list
-     { let n = match (String.uppercase $2) with
-       | "BG" 
-       | "IWD" 
-       | "BG2" -> Load.BG
-       | "PST" -> Load.PST
-       | "IWD2" -> Load.IWD2
-       | _ -> parse_error "unknown SCRIPT_STYLE" 
-       in 
-       Tp.Script_Style(n) :: $3 } 
- ; 
- 
- upper_string_list :            { [] }
- | STRING upper_string_list  { (String.uppercase $1) :: $2 } 
- ; 
- 
- tp_lang_list :   { [] } 
- | LANGUAGE STRING STRING string_list tp_lang_list
-   { { Tp.lang_name = $2 ;
-       Tp.lang_dir_name = $3 ;
-       Tp.lang_tra_files = $4 ;
-   } :: $5 } 
- ;
- 
- tp_mod_list :         { [] } 
- | BEGIN lse 
-   tp_mod_flag_list 
-   tp_action_list tp_mod_list 
-   { { Tp.mod_name = $2 ; Tp.mod_parts = $4 ; 
-       Tp.mod_flags = $3 } :: $5 }
- ; 
- 
- tp_mod_flag_list :    { [] }
- | SUBCOMPONENT lse tp_mod_flag_list 
-   { Tp.TPM_SubComponents($2,Tp.Pred_True) :: $3 } 
- | NO_LOG_RECORD tp_mod_flag_list { Tp.TPM_NotInLog :: $2 } 
- | SUBCOMPONENT lse patch_exp tp_mod_flag_list 
-   { Tp.TPM_SubComponents($2,$3) :: $4 } 
- | DEPRECATED lse tp_mod_flag_list { Tp.TPM_Deprecated($2) :: $3 }
- | DESIGNATED STRING tp_mod_flag_list { Tp.TPM_Designated(my_int_of_string $2) :: $3 }
- | REQUIRE_COMPONENT STRING STRING lse tp_mod_flag_list 
-   { Tp.TPM_RequireComponent($2,(my_int_of_string $3),$4) :: $5 } 
- | INSTALL_BY_DEFAULT tp_mod_flag_list 
-   { Tp.TPM_InstallByDefault :: $2 } 
- | FORBID_COMPONENT STRING STRING lse tp_mod_flag_list 
-   { Tp.TPM_ForbidComponent($2,(my_int_of_string $3),$4) :: $5 } 
- | REQUIRE_PREDICATE patch_exp lse tp_mod_flag_list { Tp.TPM_RequirePredicate($2,$3) :: $4 }
- ; 
- 
- tp_action_list :            { [] }
- | tp_action tp_action_list  { $1 :: $2 }
- ; 
- 
- optional_using :                { [] } 
- | USING string_list             { $2 }
- ; 
- 
- optional_plus :     { true }
- | PLUS              { false } 
- ; 
- 
- optional_equip :    { false }
- | EQUIP             { true }
- ;
- 
- optional_2h :       { true }
- | TWOHANDED           { false }
- ;
- 
- optional_glob :     { false }
- | GLOB              { true }
- ; 
- 
- tp_action : 
- | COPY optional_plus optional_glob str_str_list tp_patch_list tp_when_list 
-   { Tp.TP_Copy(
-       { Tp.copy_get_existing = false;
-         Tp.copy_use_regexp = false; 
-         Tp.copy_use_glob = $3; 
-         Tp.copy_file_list = $4 ;
-         Tp.copy_patch_list = $5 ;
-         Tp.copy_constraint_list = $6;
-         Tp.copy_backup = $2 ; 
-         Tp.copy_at_end = false ; 
-         } ) }
- | COPY_EXISTING optional_plus str_str_list tp_patch_list tp_when_list 
-   { Tp.TP_Copy(
-       { Tp.copy_get_existing = true;
-         Tp.copy_use_regexp = false; 
-         Tp.copy_use_glob = false;
-         Tp.copy_file_list = $3 ;
-         Tp.copy_patch_list = $4 ;
-         Tp.copy_constraint_list = $5;
-         Tp.copy_backup = $2 ; 
-         Tp.copy_at_end = false ; 
-         } ) }
- | COPY_EXISTING_REGEXP optional_plus optional_glob str_str_list tp_patch_list tp_when_list 
-   { Tp.TP_Copy(
-       { Tp.copy_get_existing = true;
-         Tp.copy_use_regexp = true; 
-         Tp.copy_use_glob = $3; 
-         Tp.copy_file_list = $4 ;
-         Tp.copy_patch_list = $5 ;
-         Tp.copy_constraint_list = $6;
-         Tp.copy_backup = $2 ; 
-         Tp.copy_at_end = false ; 
-         } ) }
- | COPY_RANDOM copy_random_string_list tp_patch_list tp_when_list { Tp.TP_CopyRandom($2,$3,$4) } 
- | RANDOM_SEED STRING 
-   { 
-     Tp.TP_RandomSeed(
-       try int_of_string $2
-       with _ -> ( Random.self_init () ; Random.bits () ))
-   } 
- | COMPILE optional_evaluate string_list optional_using { Tp.TP_Compile($2,$3,$4) }
- | INLINED_FILE { Tp.TP_Inlined_File($1) } 
- | MKDIR string_list { Tp.TP_Mkdir($2) } 
- | REQUIRE_FILE STRING lse { Tp.TP_Require_File($2,$3) } 
- | FORBID_FILE STRING lse { Tp.TP_Forbid_File($2,$3) } 
- | APPEND STRING STRING tp_when_list { Tp.TP_Append($2,$3,$4) } 
- | APPEND_COL STRING STRING tp_when_list 
-     { let lst = Str.split (Str.regexp "[ \t]+") $3 in
-       let lst = List.map (fun elt -> if elt = "$" then "" else elt) lst in
-       Tp.TP_Append_Col($2,lst,$4) } 
- | EXTEND_TOP STRING STRING tp_patch_list optional_using
-     { Tp.TP_Extend_Top(false,$2,$3,$4,$5) } 
- | EXTEND_BOTTOM STRING STRING tp_patch_list optional_using
-     { Tp.TP_Extend_Bottom(false,$2,$3,$4,$5) } 
- | EXTEND_TOP_REGEXP STRING STRING tp_patch_list optional_using
-     { Tp.TP_Extend_Top(true,$2,$3,$4,$5) } 
- | EXTEND_BOTTOM_REGEXP STRING STRING tp_patch_list optional_using
-     { Tp.TP_Extend_Bottom(true,$2,$3,$4,$5) } 
- | AT_EXIT STRING { Tp.TP_At_Exit($2) } 
- | AT_INTERACTIVE_EXIT STRING { Tp.TP_At_Interactive_Exit($2) } 
- | AT_INTERACTIVE_UNINSTALL STRING { Tp.TP_At_Interactive_Uninstall($2) } 
- | AT_UNINSTALL STRING { Tp.TP_At_Uninstall($2) } 
- | ADD_MUSIC STRING STRING { Tp.TP_Add_Music(
-     { Tp.music_name = $2; 
-       Tp.music_file = $3; } ) } 
- | ADD_PROJECTILE STRING { 
-   Tp.TP_Add_Projectile( { Tp.pro_file = $2; } ) }
- | STRING_SET string_lse_list { Tp.TP_String_Set($2,None) }  
- | STRING_SET string_lse_list USING STRING { Tp.TP_String_Set($2,Some($4)) }
- | STRING_SET_RANGE STRING_REF STRING_REF USING STRING 
-   { Tp.TP_String_Set_Range($2,$3,$5) } 
- | UNINSTALL STRING STRING { Tp.TP_Uninstall_Now($2,(my_int_of_string $3)) } 
- | ADD_KIT 
-     STRING 
-     STRING 
-     STRING
-     STRING
-     STRING 
-     STRING 
-     STRING 
-     STRING 
-     STRING 
-     STRING 
-     STRING 
-     STRING
-     STRING
-     STRING
-     SAY lse 
-     SAY lse 
-     SAY lse 
-   { Tp.TP_Add_Kit(
-    { Tp.kit_name = $2 ;
-     Tp.clasweap = $3 ; 
-     Tp.weapprof = $4 ;
-     Tp.abclasrq = $5 ;
-     Tp.abclsmod = $6 ;
-     Tp.abdcdsrq = $7 ;
-     Tp.abdcscrq = $8 ;
-     Tp.alignmnt = $9 ;
-     Tp.dualclas = $10 ;
-     Tp.ability_file = $11 ;
-     Tp.include_in = $12 ;
-     Tp.unused_class = $13 ;
-     Tp.tob_abbr = $14; 
-     Tp.tob_start = 
-       (let lst = Str.split (Str.regexp "[ \t]+") $15 in
-       List.map (fun elt -> if elt = "$" then "" else elt) lst) ;
-     Tp.lower = $17 ;
-     Tp.mixed = $19 ;
-     Tp.help = $21 ;
-   })}
- | FAIL lse       { Tp.TP_Fail($2) }  
- | PRINT lse       { Tp.TP_Print($2) }  
- | ACTION_IF patch_exp THEN BEGIN tp_action_list END { Tp.TP_If($2,$5,[]) } 
- | ACTION_IF patch_exp THEN BEGIN tp_action_list END ELSE 
-     BEGIN tp_action_list END { Tp.TP_If($2,$5,$9) } 
- ;
- 
- string_lse_list :               { [] }
- | STRING lse string_lse_list    { ($1,$2) :: $3 }
- ; 
- 
- /*
- tp_predicate : LPAREN patch_exp RPAREN { $2 }  
- | patch_exp AND patch_exp { Tp.Pred_And($1,$3) }
- | patch_exp OR patch_exp { Tp.Pred_Or($1,$3) }
- | NOT patch_exp { Tp.Pred_Not($2) }
- | LPAREN patch_exp RPAREN { Tp.Pred_Expr($2) } 
- | FILE_EXISTS STRING { Tp.Pred_File_Exists($2) }
- | FILE_MD5 STRING STRING { Tp.Pred_File_MD5($2,$3) }
- | FILE_EXISTS_IN_GAME STRING { Tp.Pred_File_Exists_In_Game($2) }
- | FILE_SIZE STRING STRING { Tp.Pred_File_Size($2,my_int_of_string $3) }
- | FILE_SIZE STRING STRING { Tp.Pred_File_Size($2,my_int_of_string $3) }
- | FILE_CONTAINS STRING STRING { Tp.Pred_File_Contains($2,$3) }
- ;
- */
- 
- 
- string_list :            { [] }
- | STRING string_list  { $1 :: $2 } 
- ; 
- 
- copy_random_string_list : { [] }
- | LPAREN string_list RPAREN copy_random_string_list { $2 :: $4 } 
- ; 
- 
- 
- int_list:   { [] }
- | STRING int_list  { (my_int_of_string $1) :: $2 }
- ;
- 
- tp_when_list :                 { [] }
- | IF STRING tp_when_list       { Tp.TP_Contains($2) :: $3 }
- | UNLESS STRING tp_when_list   { Tp.TP_NotContains($2) :: $3 } 
- | IF_SIZE_IS STRING tp_when_list { Tp.TP_IfSizeIs(my_int_of_string $2) :: $3 }
- | IF_EVAL patch_exp tp_when_list { Tp.TP_Eval($2) :: $3 }
- | BUT_ONLY_IF_IT_CHANGES tp_when_list        { Tp.TP_ButOnlyIfItChanges :: $2 } 
- ; 
- 
- str_str_list :               { [] }
- | STRING STRING str_str_list { ($1,$2) :: $3 } 
- ; 
- 
- patch_STRING : STRING           { Tp.PE_LiteralString $1 }
- | EVALUATE_BUFFER patch_STRING  { Tp.PE_Evaluate $2 } 
- ; 
- 
- dlg_or_patch_STRING : lse       { Tp.PE_Tlk($1) }
- | EVALUATE_BUFFER patch_STRING  { Tp.PE_Pe (Tp.PE_Evaluate $2)  } 
- ; 
- 
- patch_exp : patch_STRING              { Tp.PE_String($1) }
- | LPAREN patch_exp RPAREN       { $2 } 
- | patch_STRING STRING_EQUAL patch_STRING    { Tp.PE_StringEqual($1,$3,false) } 
- | patch_STRING STRING_EQUAL_CASE patch_STRING    { Tp.PE_StringEqual($1,$3,true) } 
- | patch_STRING STRING_MATCHES_REGEXP patch_STRING { Tp.PE_StringRegexp($1,$3,true) } 
- | patch_STRING STRING_CONTAINS_REGEXP patch_STRING { Tp.PE_StringRegexp($1,$3,false) } 
- | RANDOM LPAREN patch_exp patch_exp RPAREN { Tp.PE_Random($3,$4) } 
- | FILE_CONTAINS_EVALUATED LPAREN patch_STRING patch_STRING RPAREN 
-   { Tp.PE_FileContainsEvaluated($3,$4) } 
- | FILE_EXISTS patch_STRING { Tp.Pred_File_Exists($2) }
- | FILE_MD5 patch_STRING patch_STRING { Tp.Pred_File_MD5($2,$3) }
- | FILE_EXISTS_IN_GAME patch_STRING { Tp.Pred_File_Exists_In_Game($2) }
- | FILE_SIZE patch_STRING STRING { Tp.Pred_File_Size($2,my_int_of_string $3) }
- | FILE_CONTAINS patch_STRING patch_STRING { Tp.Pred_File_Contains($2,$3) }
- | patch_exp PLUS patch_exp      { Tp.PE_Add($1,$3) } 
- | patch_exp MINUS patch_exp      { Tp.PE_Sub($1,$3) } 
- | patch_exp TIMES patch_exp      { Tp.PE_Mul($1,$3) } 
- | patch_exp DIVIDE patch_exp      { Tp.PE_Div($1,$3) } 
- | patch_exp TIMESTIMES patch_exp      { Tp.PE_Exp($1,$3,Tp.Pred_True) } 
- | patch_exp TIMESTIMES LPAREN patch_exp patch_exp RPAREN     
-   { Tp.PE_Exp($1,$4,$5) } 
- | patch_exp EQUALS patch_exp  { Tp.PE_Equal($1,$3) }  
- | patch_exp EQUALSEQUALS patch_exp  { Tp.PE_Equal($1,$3) }  
- | patch_exp NOTEQUALS patch_exp { Tp.PE_Not(Tp.PE_Equal($1,$3)) }
- | NOT patch_exp               { Tp.PE_Not($2) } 
- | patch_exp AND patch_exp  { Tp.PE_And($1,$3) } 
- | patch_exp OR patch_exp  { Tp.PE_Or($1,$3) } 
- | patch_exp GT patch_exp  { Tp.PE_GT($1,$3) } 
- | patch_exp GTE patch_exp  { Tp.PE_GTE($1,$3) } 
- | patch_exp LT patch_exp  { Tp.PE_LT($1,$3) } 
- | patch_exp LTE patch_exp  { Tp.PE_LTE($1,$3) } 
- 
- | patch_exp BAND patch_exp  { Tp.PE_BAND($1,$3) } 
- | patch_exp BOR patch_exp  { Tp.PE_BOR($1,$3) } 
- | BNOT patch_exp  { Tp.PE_BNOT($2) } 
- | patch_exp BXOR patch_exp  { Tp.PE_BXOR($1,$3) } 
- | patch_exp BLSL patch_exp  { Tp.PE_BLSL($1,$3) } 
- | patch_exp BLSR patch_exp  { Tp.PE_BLSR($1,$3) } 
- | patch_exp BASR patch_exp  { Tp.PE_BASR($1,$3) } 
- 
- | patch_exp QUESTION patch_exp COLON patch_exp { Tp.PE_If($1,$3,$5); } 
- ;
- 
- tp_patch_list :   { [] }
- | tp_patch tp_patch_list { $1 :: $2 }
- ;
- 
- tp_patch   : 
- | SAY patch_exp lse { Tp.TP_PatchStrRef($2,$3) }
- | SAY_EVALUATED patch_exp STRING { Tp.TP_PatchStrRefEvaluated($2,$3) }
- | DESCRIBE_ITEM STRING { Tp.TP_DescribeItem($2) } 
- | REPLACE STRING lse { Tp.TP_PatchString($2,$3) }
- | REPLACE_TEXTUALLY STRING STRING { Tp.TP_PatchStringTextually($2,$3) }
- | REPLACE_EVALUATE STRING BEGIN tp_patch_list END STRING { Tp.TP_PatchStringEvaluate($2,$4,$6) }
- | REPLACE_BCS_BLOCK STRING STRING { Tp.TP_PatchReplaceBCSBlock($2,$3) } 
- | REPLACE_BCS_BLOCK_REGEXP STRING STRING { Tp.TP_PatchReplaceBCSBlockRE($2,$3) } 
- | APPLY_BCS_PATCH STRING { Tp.TP_PatchApplyBCSPatch($2,None) }
- | APPLY_BCS_PATCH_OR_COPY STRING STRING { Tp.TP_PatchApplyBCSPatch($2,Some($3)) }
- | READ_STRREF patch_exp STRING { Tp.TP_PatchReadStrRef($2,$3,None) } 
- | READ_STRREF patch_exp STRING ELSE STRING { Tp.TP_PatchReadStrRef($2,$3,Some($5) ) } 
- | READ_ASCII patch_exp STRING LPAREN patch_exp RPAREN { Tp.TP_PatchReadAscii($2,$3,None,Some($5)) }
- | READ_ASCII patch_exp STRING ELSE STRING LPAREN patch_exp RPAREN { Tp.TP_PatchReadAscii($2,$3,Some($5),Some($7)) } 
- | READ_ASCII patch_exp STRING { Tp.TP_PatchReadAscii($2,$3,None,None) }
- | READ_ASCII patch_exp STRING ELSE STRING { Tp.TP_PatchReadAscii($2,$3,Some($5),None) }
- | READ_BYTE patch_exp STRING { Tp.TP_PatchReadByte($2,$3,None) } 
- | READ_SBYTE patch_exp STRING { Tp.TP_PatchReadSByte($2,$3,None) } 
- | READ_SSHORT patch_exp STRING { Tp.TP_PatchReadSShort($2,$3,None) } 
- | READ_BYTE patch_exp STRING ELSE patch_exp { Tp.TP_PatchReadByte($2,$3,Some($5) ) } 
- | READ_SHORT patch_exp STRING { Tp.TP_PatchReadShort($2,$3,None) } 
- | READ_SHORT patch_exp STRING ELSE patch_exp { Tp.TP_PatchReadShort($2,$3,Some($5)) } 
- | READ_LONG patch_exp STRING { Tp.TP_PatchReadLong($2,$3,None) } 
- | READ_LONG patch_exp STRING ELSE patch_exp { Tp.TP_PatchReadLong($2,$3,Some($5)) } 
- | WRITE_FILE patch_exp STRING { Tp.TP_PatchWriteFile($2,$3,false) }  
- | INSERT_FILE patch_exp STRING { Tp.TP_PatchWriteFile($2,$3,true) }  
- | APPEND_FILE STRING { Tp.TP_PatchAppendFile($2) }  
- | WRITE_BYTE patch_exp patch_exp { Tp.TP_PatchByte($2,$3) } 
- | WRITE_SHORT patch_exp patch_exp { Tp.TP_PatchShort($2,$3) } 
- | WRITE_LONG patch_exp patch_exp { Tp.TP_PatchLong($2,$3) } 
- | WRITE_ASCII patch_exp STRING { Tp.TP_PatchASCII($2,$3,false,None) } 
- | WRITE_ASCII patch_exp STRING STRING_REF { Tp.TP_PatchASCII($2,$3,false,Some($4)) } 
- | WRITE_EVALUATED_ASCII patch_exp STRING { Tp.TP_PatchASCII($2,$3,true,None) } 
- | WRITE_EVALUATED_ASCII patch_exp STRING STRING_REF { Tp.TP_PatchASCII($2,$3,true,Some($4)) } 
- | INSERT_BYTES patch_exp patch_exp { Tp.TP_PatchInsertBytes($2,$3) }
- | DELETE_BYTES patch_exp patch_exp { Tp.TP_PatchDeleteBytes($2,$3) }
- | SET patch_STRING EQUALS patch_exp { Tp.TP_PatchSet($2,$4) } 
- 
- | STRING PLUS_EQUALS patch_exp 
-   { Tp.TP_PatchSet(Tp.PE_LiteralString $1,(Tp.PE_Add(Tp.PE_String(Tp.PE_LiteralString $1),$3))) } 
- | STRING MINUS_EQUALS patch_exp 
-   { Tp.TP_PatchSet(Tp.PE_LiteralString $1,(Tp.PE_Sub(Tp.PE_String(Tp.PE_LiteralString $1),$3))) } 
- | STRING TIMES_EQUALS patch_exp 
-   { Tp.TP_PatchSet(Tp.PE_LiteralString $1,(Tp.PE_Mul(Tp.PE_String(Tp.PE_LiteralString $1),$3))) } 
- | STRING DIVIDE_EQUALS patch_exp 
-   { Tp.TP_PatchSet(Tp.PE_LiteralString $1,(Tp.PE_Div(Tp.PE_String(Tp.PE_LiteralString $1),$3))) } 
- | STRING OR_EQUALS patch_exp 
-   { Tp.TP_PatchSet(Tp.PE_LiteralString $1,(Tp.PE_BOR(Tp.PE_String(Tp.PE_LiteralString $1),$3))) } 
- | STRING AND_EQUALS patch_exp 
-   { Tp.TP_PatchSet(Tp.PE_LiteralString $1,(Tp.PE_BAND(Tp.PE_String(Tp.PE_LiteralString $1),$3))) } 
- | STRING BLSL_EQUALS patch_exp
-     { Tp.TP_PatchSet(Tp.PE_LiteralString $1,(Tp.PE_BLSL(Tp.PE_String(Tp.PE_LiteralString $1),$3))) }
- | STRING BLSR_EQUALS patch_exp
-     { Tp.TP_PatchSet(Tp.PE_LiteralString $1,(Tp.PE_BLSR(Tp.PE_String(Tp.PE_LiteralString $1),$3))) }
- 
- 
- 
- | SET patch_STRING PLUS_EQUALS patch_exp 
-   { Tp.TP_PatchSet($2,(Tp.PE_Add(Tp.PE_String($2),$4))) } 
- | SET patch_STRING MINUS_EQUALS patch_exp 
-   { Tp.TP_PatchSet($2,(Tp.PE_Sub(Tp.PE_String($2),$4))) } 
- | SET patch_STRING TIMES_EQUALS patch_exp 
-   { Tp.TP_PatchSet($2,(Tp.PE_Mul(Tp.PE_String($2),$4))) } 
- | SET patch_STRING DIVIDE_EQUALS patch_exp 
-   { Tp.TP_PatchSet($2,(Tp.PE_Div(Tp.PE_String($2),$4))) } 
- | SET patch_STRING OR_EQUALS patch_exp 
-   { Tp.TP_PatchSet($2,(Tp.PE_BOR(Tp.PE_String($2),$4))) } 
- | SET patch_STRING AND_EQUALS patch_exp 
-   { Tp.TP_PatchSet($2,(Tp.PE_BAND(Tp.PE_String($2),$4))) } 
- | SET patch_STRING BLSL_EQUALS patch_exp
-   { Tp.TP_PatchSet($2,(Tp.PE_BLSL(Tp.PE_String($2),$4))) }
- | SET patch_STRING BLSR_EQUALS patch_exp
-   { Tp.TP_PatchSet($2,(Tp.PE_BLSR(Tp.PE_String($2),$4))) }
- 
- | SET_IDS_SYMBOL_OF_INT STRING STRING patch_exp 
-   { Tp.TP_PatchSetIdsSymOfInt($2,$3,$4) } 
- | STRING EQUALS patch_exp { Tp.TP_PatchSet(Tp.PE_LiteralString $1,$3) } 
- | ADD_KNOWN_SPELL STRING STRING_REF STRING { Tp.TP_Add_Known_Spell($2,$3,$4) }
- | WHILE patch_exp BEGIN tp_patch_list END { Tp.TP_PatchWhile($2,$4) }
- | FOR LPAREN tp_patch_list SEMICOLON patch_exp SEMICOLON tp_patch_list 
-     RPAREN BEGIN tp_patch_list END { Tp.TP_PatchFor($3,$5,$7,$10) } 
- | PATCH_RANDOM_SEED patch_exp { Tp.TP_PatchRandomSeed($2) } 
- | PATCH_IF patch_exp optional_then BEGIN tp_patch_list END { Tp.TP_PatchIf($2,$5,[]) }
- | INNER_ACTION BEGIN tp_action_list END { Tp.TP_PatchInnerAction($3) } 
- | INNER_PATCH STRING BEGIN tp_patch_list END { Tp.TP_PatchInnerBuff($2,$4) } 
- | INNER_PATCH_FILE STRING BEGIN tp_patch_list END { Tp.TP_PatchInnerBuffFile($2,$4) } 
- | PATCH_IF patch_exp optional_then BEGIN tp_patch_list END ELSE BEGIN tp_patch_list END { Tp.TP_PatchIf($2,$5,$9) }
- | PATCH_IF patch_exp optional_then BEGIN tp_patch_list END ELSE tp_patch { Tp.TP_PatchIf($2,$5,[$8]) }
- | PATCH_PRINT lse       { Tp.TP_PatchPrint($2) } 
- | SPRINT patch_STRING dlg_or_patch_STRING     { Tp.TP_PatchSprint($2,$3) } 
- | SNPRINT patch_exp patch_STRING dlg_or_patch_STRING     { Tp.TP_PatchSnprint($2,$3,$4) } 
- | SET_2DA_ENTRY patch_exp patch_exp patch_exp patch_exp { Tp.TP_Patch2DA($2,$3,$4,$5) }
- | SET_2DA_ENTRY_LATER STRING patch_exp patch_exp patch_exp { Tp.TP_Patch2DALater($2,$3,$4,$5) } 
- | SET_2DA_ENTRIES_NOW STRING patch_exp { Tp.TP_Patch2DANow($2,$3) } 
- | ADD_MAP_NOTE STRING_REF STRING_REF STRING lse 
-   { Tp.TP_Add_Map_Note(
-    {Tp.xcoord = $2 ;
-     Tp.ycoord = $3 ;
-     Tp.mstring = $5 ;
-     Tp.colour = $4 ; })}
- | COUNT_2DA_ROWS patch_exp STRING { Tp.TP_Get2DARows($2,$3) } 
- | READ_2DA_ENTRY patch_exp patch_exp patch_exp STRING { Tp.TP_Read2DA($2,$3,$4,$5) }
- | ADD_CRE_ITEM 
-    STRING
-    STRING_REF 
-    STRING_REF 
-    STRING_REF 
-    STRING 
-    STRING 
-    optional_equip
-    optional_2h
-   { Tp.TP_Add_Cre_Item(
-    { Tp.item_name = $2 ;
-      Tp.i_charge1 = $3 ;
-      Tp.i_charge2 = $4 ;
-      Tp.i_charge3 = $5 ;
-      Tp.i_flags = $6 ;
-      Tp.item_slot = $7 ;
-      Tp.equip = $8 ;
-      Tp.twohanded_weapon = $9 ;})}
- | PATCH_GAM STRING STRING STRING_REF STRING_REF { Tp.TP_Patch_Gam($2,$3,$4,$5) }
- | ADD_STORE_ITEM optional_plus STRING STRING_REF STRING_REF STRING_REF STRING STRING_REF { Tp.TP_Add_S_Item({ Tp.overwrite_store_item = $2; },$3,$4,$5,$6,$7,$8,None) }
- | ADD_STORE_ITEM optional_plus STRING STRING_REF STRING_REF STRING_REF STRING STRING_REF STRING { Tp.TP_Add_S_Item({ Tp.overwrite_store_item = $2; },$3,$4,$5,$6,$7,$8,Some($9)) }
- | REMOVE_KNOWN_SPELL upper_string_list { Tp.TP_Remove_Known_Spell($2) }
- | COMPILE_BAF_TO_BCS { Tp.TP_CompileBAFtoBCS } 
- | DECOMPILE_BCS_TO_BAF { Tp.TP_CompileBCStoBAF } 
- | COMPILE_D_TO_DLG { Tp.TP_CompileDtoDLG } 
- | DECOMPILE_DLG_TO_D { Tp.TP_CompileDLGtoD } 
- | EVALUATE_BUFFER { Tp.TP_EvaluateBuffer }
- ; 
- 
  log_file : installed_mod_list { $1 }
  ;
  
--- 775,780 ----
