*** WeiDU-185/src/var.ml	Wed May 18 21:42:12 2005
--- WeiDU/src/var.ml	Sun Apr  6 22:21:01 2008
***************
*** 1,7 ****
--- 1,17 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.var.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (*
   * TP2 Patch Variables
   *)
  
+ open Util
+ 
  let debug_assign = ref false 
  
  type variable_value = 
***************
*** 10,15 ****
--- 20,29 ----
  
  let variables = Hashtbl.create 255
  
+ let arrays : (string, string list list) Hashtbl.t = Hashtbl.create 255
+ 
+ let cli_variables : string list option ref = ref None
+ 
  let set_int32 name value =
    let name = "%" ^ name ^ "%" in
    (if !debug_assign then Util.log_and_print "SET %s = %ld\n" name value) ; 
***************
*** 25,32 ****
--- 39,78 ----
    (if !debug_assign then Util.log_and_print "SET %s = ~%s~\n" name value) ;
    Hashtbl.replace variables name (String(value))
  
+ let add_local_int32 name value =
+   let name = "%" ^ name ^ "%" in
+   (if !debug_assign then Util.log_and_print "SET %s = %ld\n" name value) ;
+   Hashtbl.add variables name (Int32(value))
+ 
+ let add_local_string name value =
+   let name = "%" ^ name ^ "%" in
+   (if !debug_assign then Util.log_and_print "LOCAL_SET %s = ~%s~\n" name value) ;
+   Hashtbl.add variables name (String(value))
+ 
+ let remove_local name =
+   let name = "%" ^ name ^ "%" in
+   Hashtbl.remove variables name
+ 
  let variable_regexp = Str.regexp "%[^%]+%"
+ (* 
+ let my_global_substitute expr repl_fun text =
+   let rec replace start last_was_empty =
+     try
+       let startpos = if last_was_empty then start + 1 else start - 1 in
+       let startpos = if startpos < 0 then 0 else startpos in
+       let start = if last_was_empty || startpos <= 0 then start else start - 1 in
+       if startpos > String.length text then raise Not_found;
+       let pos = Str.search_forward expr text startpos in
+       let end_pos = Str.match_end() in
+       let repl_text = repl_fun text in
+       String.sub text start (pos-start) ::
+       repl_text ::
+       replace end_pos (end_pos = pos)
+     with Not_found ->
+       [Str.string_after text start] in
+   String.concat "" (replace 0 false)
  
+  *)
  let get_string str =
    let res =
    Str.global_substitute variable_regexp
***************
*** 42,52 ****
    (if !debug_assign then Util.log_and_print "GET ~%s~ = ~%s~\n" str res) ; 
    res
  
  let assoc name value = 
    let value = Int32.of_int value in 
    Hashtbl.replace variables name (Int32 value) 
  
! let _ = 
    assoc "AREA_CITY" 0252 ;
    assoc "AREA_DAY" 0260 ;
    assoc "AREA_DUNGEON" 0256 ;
--- 88,110 ----
    (if !debug_assign then Util.log_and_print "GET ~%s~ = ~%s~\n" str res) ;
    res
  
+ let get_string_exact str =
+   match Hashtbl.find variables str with
+   | Int32(v) -> Int32.to_string v
+   | String(s) -> s
+ 
+ 
+ let clear_var a =
+   let var_spec = Hashtbl.copy variables in
+   Hashtbl.iter ( fun a b -> Hashtbl.remove variables a 
+   ) var_spec ;
+   Hashtbl.clear variables
+ 
  let assoc name value =
    let value = Int32.of_int value in
    Hashtbl.replace variables name (Int32 value)
  
! let all_the_assoc a =
    assoc "AREA_CITY" 0252 ;
    assoc "AREA_DAY" 0260 ;
    assoc "AREA_DUNGEON" 0256 ;
***************
*** 150,152 ****
--- 208,214 ----
  
    ()
  
+ let _ =
+   all_the_assoc () ;
+   ()
+ 
