*** WeiDU-185/zlib/zutil.c	Fri Sep 27 03:25:32 2002
--- WeiDU/zlib/zutil.c	Sat Sep  1 02:40:48 2007
***************
*** 1,5 ****
  /* zutil.c -- target dependent utility functions for the compression library
!  * Copyright (C) 1995-2002 Jean-loup Gailly.
   * For conditions of distribution and use, see copyright notice in zlib.h 
   */
  
--- 1,5 ----
  /* zutil.c -- target dependent utility functions for the compression library
!  * Copyright (C) 1995-2005 Jean-loup Gailly.
   * For conditions of distribution and use, see copyright notice in zlib.h
   */
  
***************
*** 7,19 ****
  
  #include "zutil.h"
  
  struct internal_state      {int dummy;}; /* for buggy compilers */
- 
- #ifndef STDC
- extern void exit OF((int));
  #endif
  
! const char *z_errmsg[10] = {
  "need dictionary",     /* Z_NEED_DICT       2  */
  "stream end",          /* Z_STREAM_END      1  */
  "",                    /* Z_OK              0  */
--- 7,17 ----
  
  #include "zutil.h"
  
+ #ifndef NO_DUMMY_DECL
  struct internal_state      {int dummy;}; /* for buggy compilers */
  #endif
  
! const char * const z_errmsg[10] = {
  "need dictionary",     /* Z_NEED_DICT       2  */
  "stream end",          /* Z_STREAM_END      1  */
  "",                    /* Z_OK              0  */
***************
*** 31,36 ****
--- 29,117 ----
      return ZLIB_VERSION;
  }
  
+ uLong ZEXPORT zlibCompileFlags()
+ {
+     uLong flags;
+ 
+     flags = 0;
+     switch (sizeof(uInt)) {
+     case 2:     break;
+     case 4:     flags += 1;     break;
+     case 8:     flags += 2;     break;
+     default:    flags += 3;
+     }
+     switch (sizeof(uLong)) {
+     case 2:     break;
+     case 4:     flags += 1 << 2;        break;
+     case 8:     flags += 2 << 2;        break;
+     default:    flags += 3 << 2;
+     }
+     switch (sizeof(voidpf)) {
+     case 2:     break;
+     case 4:     flags += 1 << 4;        break;
+     case 8:     flags += 2 << 4;        break;
+     default:    flags += 3 << 4;
+     }
+     switch (sizeof(z_off_t)) {
+     case 2:     break;
+     case 4:     flags += 1 << 6;        break;
+     case 8:     flags += 2 << 6;        break;
+     default:    flags += 3 << 6;
+     }
+ #ifdef DEBUG
+     flags += 1 << 8;
+ #endif
+ #if defined(ASMV) || defined(ASMINF)
+     flags += 1 << 9;
+ #endif
+ #ifdef ZLIB_WINAPI
+     flags += 1 << 10;
+ #endif
+ #ifdef BUILDFIXED
+     flags += 1 << 12;
+ #endif
+ #ifdef DYNAMIC_CRC_TABLE
+     flags += 1 << 13;
+ #endif
+ #ifdef NO_GZCOMPRESS
+     flags += 1L << 16;
+ #endif
+ #ifdef NO_GZIP
+     flags += 1L << 17;
+ #endif
+ #ifdef PKZIP_BUG_WORKAROUND
+     flags += 1L << 20;
+ #endif
+ #ifdef FASTEST
+     flags += 1L << 21;
+ #endif
+ #ifdef STDC
+ #  ifdef NO_vsnprintf
+         flags += 1L << 25;
+ #    ifdef HAS_vsprintf_void
+         flags += 1L << 26;
+ #    endif
+ #  else
+ #    ifdef HAS_vsnprintf_void
+         flags += 1L << 26;
+ #    endif
+ #  endif
+ #else
+         flags += 1L << 24;
+ #  ifdef NO_snprintf
+         flags += 1L << 25;
+ #    ifdef HAS_sprintf_void
+         flags += 1L << 26;
+ #    endif
+ #  else
+ #    ifdef HAS_snprintf_void
+         flags += 1L << 26;
+ #    endif
+ #  endif
+ #endif
+     return flags;
+ }
+ 
  #ifdef DEBUG
  
  #  ifndef verbose
***************
*** 55,60 ****
--- 136,148 ----
      return ERR_MSG(err);
  }
  
+ #if defined(_WIN32_WCE)
+     /* The Microsoft C Run-Time Library for Windows CE doesn't have
+      * errno.  We define it as a global variable to simplify porting.
+      * Its value is always 0 and should not be used.
+      */
+     int errno = 0;
+ #endif
  
  #ifndef HAVE_MEMCPY
  
***************
*** 93,103 ****
  }
  #endif
  
  #ifdef __TURBOC__
! #if (defined( __BORLANDC__) || !defined(SMALL_MEDIUM)) && !defined(__32BIT__)
! /* Small and medium model in Turbo C are for now limited to near allocation
!  * with reduced MAX_WBITS and MAX_MEM_LEVEL
!  */
  #  define MY_ZCALLOC
  
  /* Turbo C malloc() does not allow dynamic allocation of 64K bytes
--- 181,192 ----
  }
  #endif
  
+ 
+ #ifdef SYS16BIT
+ 
  #ifdef __TURBOC__
! /* Turbo C in 16-bit mode */
! 
  #  define MY_ZCALLOC
  
  /* Turbo C malloc() does not allow dynamic allocation of 64K bytes
***************
*** 169,179 ****
      ptr = opaque; /* just to make some compilers happy */
      Assert(0, "zcfree: ptr not found");
  }
! #endif
  #endif /* __TURBOC__ */
  
  
! #if defined(M_I86) && !defined(__32BIT__)
  /* Microsoft C in 16-bit mode */
  
  #  define MY_ZCALLOC
--- 258,268 ----
      ptr = opaque; /* just to make some compilers happy */
      Assert(0, "zcfree: ptr not found");
  }
! 
  #endif /* __TURBOC__ */
  
  
! #ifdef M_I86
  /* Microsoft C in 16-bit mode */
  
  #  define MY_ZCALLOC
***************
*** 195,206 ****
      _hfree(ptr);
  }
  
! #endif /* MSC */
  
  
  #ifndef MY_ZCALLOC /* Any system without a special alloc function */
  
  #ifndef STDC
  extern voidp  calloc OF((uInt items, uInt size));
  extern void   free   OF((voidpf ptr));
  #endif
--- 284,298 ----
      _hfree(ptr);
  }
  
! #endif /* M_I86 */
! 
! #endif /* SYS16BIT */
  
  
  #ifndef MY_ZCALLOC /* Any system without a special alloc function */
  
  #ifndef STDC
+ extern voidp  malloc OF((uInt size));
  extern voidp  calloc OF((uInt items, uInt size));
  extern void   free   OF((voidpf ptr));
  #endif
***************
*** 211,217 ****
      unsigned size;
  {
      if (opaque) items += size - size; /* make compiler happy */
!     return (voidpf)calloc(items, size);
  }
  
  void  zcfree (opaque, ptr)
--- 303,310 ----
      unsigned size;
  {
      if (opaque) items += size - size; /* make compiler happy */
!     return sizeof(uInt) > 2 ? (voidpf)malloc(items * size) :
!                               (voidpf)calloc(items, size);
  }
  
  void  zcfree (opaque, ptr)
